#include "stdafx.h"

cBackSurface::cBackSurface()
		: cSurface(GAME_X, 0, GAME_DX, GAME_DY, (int)(0.7 * LEVEL_SIZE), GAME_EDGE, FALSE, FALSE, DIRTY_BLOCK)
{
}

void cBackSurface::write_dirty()
{     
	write_tiled(backgr);
	
	write_displayable(scenery_back1);
	write_displayable(scenery_back2);
}

cGameSurface::cGameSurface()
		: cSurface(GAME_X, 0, GAME_DX, GAME_DY, LEVEL_SIZE, GAME_EDGE, TRUE, FALSE, DIRTY_BLOCK)
{
}

void cGameSurface::write_dirty()
{      
	clear_dirty(mask_color);
	
	write_displayable(scenery_game1);
	write_displayable(structures);
	write_displayable(stairs);
	write_displayable(players);
	write_displayable(weapons);
	write_displayable(bonus);
	write_displayable(bubbles);
	write_displayable(effects);	
	write_displayable(scenery_game2);
	write_displayable(scenery_game3);
	write_displayable(parts);
	write_displayable(disaster);		

	write_displayable(controllers);
	write_displayable(texts);
}

cLeftSurface::cLeftSurface()
		: cSurface(0, 0, GAME_X, GAME_DY, GAME_DY, 0, FALSE, TRUE, DIRTY_BLOCK)
{	
}

void cLeftSurface::write_dirty()
{
	write_tiled(ambient1);
	
	write_displayable(images_left);
	write_displayable(texts_left);
}

cRightSurface::cRightSurface()
		: cSurface(GAME_X + GAME_DX, 0, GAME_X, GAME_DY, GAME_DY, 0, FALSE, TRUE, DIRTY_BLOCK)
{	
}

void cRightSurface::write_dirty()
{
	write_tiled(ambient2);
	
	write_displayable(images_right);
	write_displayable(texts_right);
}

cNonParallaxSurface::cNonParallaxSurface()
		: cSurface(GAME_X, 0, GAME_DX, GAME_DY, LEVEL_SIZE, GAME_EDGE, FALSE, TRUE, DIRTY_BLOCK)
{
}

void cNonParallaxSurface::write_dirty()
{      
	write_tiled(backgr);
	
	write_displayable(scenery_back1);
	write_displayable(scenery_back2);
	write_displayable(scenery_game1);
	write_displayable(structures);
	write_displayable(stairs);
	write_displayable(players);
	write_displayable(weapons);
	write_displayable(bonus);
	write_displayable(bubbles);
	write_displayable(effects);
	write_displayable(disaster);		
	write_displayable(scenery_game2);
	write_displayable(scenery_game3);
	write_displayable(parts);
	write_displayable(controllers);
	write_displayable(texts);	
}

cInfoSurface::cInfoSurface()
		: cSurface(GAME_X, 0, GAME_DX, GAME_DY, GAME_DY, 0, TRUE, FALSE, DIRTY_BLOCK)
{
}

void cInfoSurface::write_dirty()
{
}
